/** Copyright (C) 2017 by Bundesanstalt für Gewässerkunde
 * Software engineering by
 *  Björnsen Beratende Ingenieure GmbH
 *  Dr. Schumacher Ingenieurbüro für Wasser und Umwelt
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */
package org.dive4elements.river.artifacts.uinfo.salix;

import org.dive4elements.artifacts.Artifact;
import org.dive4elements.artifacts.CallContext;
import org.dive4elements.artifacts.common.utils.XMLUtils.ElementCreator;
import org.dive4elements.river.artifacts.D4EArtifact;
import org.dive4elements.river.artifacts.access.RangeAccess;
import org.dive4elements.river.artifacts.states.DefaultState;
import org.w3c.dom.Element;

/**
 * @author Domenico Nardi Tironi
 */
public class SupraRegionalTableState extends DefaultState {

    private static final long serialVersionUID = 1L;

    @Override
    protected String getUIProvider() {
        return "uinfo.salix.supraregional.table";
    }

    @Override
    protected Element[] createItems(final ElementCreator cr, final Artifact artifact, final String name, final CallContext context) {
        final String datakey = "supraregional_table";
        if (name.equals(datakey)) {

            final D4EArtifact flys = (D4EArtifact) artifact;
            final String s = flys.getDataAsString(datakey);

            final RangeAccess ra = new RangeAccess((D4EArtifact) artifact);

            final Element item = createItem(cr, new String[] { "salix_zones", s });
            final Element min = createItem(cr, new String[] { "salix_zones_min", new Double(ra.getFrom()).toString() });

            final Element max = createItem(cr, new String[] { "salix_zones_max", new Double(ra.getTo()).toString() });

            return new Element[] { min, max, item };

        }

        return new Element[] {};
    }

}